{- 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
-}
module Haskell11DynamicTyping where

wrapH :: TC a => a -> Dynamic
wrapH x = `dynamic x

unwrapH :: TC a => Dynamic -> Maybe a
unwrapH (x :: a^) = Just x
unwrapH _         = Nothing

wrappedId :: Dynamic
wrappedId = `dynamic id :: A.a: a -> a