{- 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
-}
module Haskell3Functions where


fibsH :: [Int]
fibsH = 1 : 1 : zipWith (+) fibsH (tail fibsH)

type ListF a b = a -> [b]

concatMap2H, concatMap1H, concatMap0H :: ListF a b -> ListF [a] b
concatMap2H f xs =          concat (map f xs)
concatMap1H f    = \xs ->   concat (map f xs)
concatMap0H      = \f xs -> concat (map f xs)

