implementation module Data.Maybe where

import Prelude (Maybe(..))
from StdMisc import abort

isNothing :: !Maybe a -> Bool
isNothing Nothing = True
isNothing _ = False

isJust :: !Maybe a -> Bool
isJust (Just _) = True
isJust _ = False

fromJust :: !Maybe a -> a
fromJust (Just a) = a
fromJust _ = abort `"Maybe.fromJust: Nothing"
