definition module Foreign.Marshal.Utils where

from PreludeTypes import qualified ::IO
from Foreign.Ptr import qualified ::Ptr
from Foreign.Storable import qualified class Storable

with` :: Foreign.Storable.Storable a => !a -> !(Foreign.Ptr.Ptr a -> PreludeTypes.IO b) -> PreludeTypes.IO b
-- withMany :: (a -> (b -> r) -> r) -> [a] -> ([b] -> r) -> r
withMany g l f
	:== withMany l f
 where
	withMany (x:xs) f
		= g x (\y -> withMany xs (\ys -> f (y:ys)))
	withMany [] f
		= f []
