definition module PreludeRatio where

from PreludeTypes import
	class Show,class Num,class Eq,class Ord,class Real,class Enum,class Integral,class RealFrac,class Read,
	::Integer,::Rational,::Ratio,::Ordering;

from PreludeInline import
	class Fractional;

instance (Integral a) => Eq (Ratio a) where
	(==) :: (Integral a) => !(Ratio a) -> !(Ratio a) -> Bool special a=Integer
	(/=) :: (Integral a) => !(Ratio a) -> !(Ratio a) -> Bool special a=Integer

instance (Integral a) => Ord (Ratio a) where
	(<=) :: (Integral a) => !(Ratio a) -> !(Ratio a) -> Bool special a=Integer
	(<) :: (Integral a) => !(Ratio a) -> !(Ratio a) -> Bool special a=Integer

instance (Integral a) => Num (Ratio a) special a=Integer

instance (Integral a) => Real (Ratio a) special a=Integer

instance (Integral a) => Fractional (Ratio a) special a=Integer

instance (Integral a) => RealFrac (Ratio a)

instance (Integral a) => Enum (Ratio a) where
	pred :: (Integral a) => (Ratio a) -> Ratio a special a=Integer
	succ :: (Integral a) => (Ratio a) -> Ratio a special a=Integer
	toEnum :: (Integral a) => (Int -> Ratio a) special a=Integer

instance (Integral a) => Show (Ratio a) special a=Integer

instance (Read a, Integral a) => Read (Ratio a) special a=Integer
