implementation module _PreludeEnum

import PreludeInline

from StdClass import class IncDec (..),class zero(..),class one(..)
from StdOverloaded import qualified class +(..),class -(..)
from StdInt import instance + Int,instance - Int,instance zero Int,instance one Int
from StdChar import instance + Char,instance - Char,instance zero Char,instance one Char
from StdBool import not 

_from :: a -> .[a] | IncDec a
_from n
	= [n : _from (inc n)]

_from_to :: !a !a -> .[a] | Ord,IncDec a
_from_to n e
	| n <= e
		= [n : _from_to (inc n) e]
		= []

_from_then :: a a -> .[a] | Ord,IncDec a
_from_then n1 n2
	= [n1 : _from_by n2 (n2 StdOverloaded@- n1)]
where
	_from_by :: a a -> .[a] | Ord,IncDec a
	_from_by n s
		= [n : _from_by (n StdOverloaded@+ s) s]

_from_then_to :: !a !a !a -> .[a] | Ord,IncDec a
_from_then_to n1 n2 e
	| n1 <= n2
		= _from_by_to n1 (n2 StdOverloaded@- n1) e
		= _from_by_down_to n1 (n2 StdOverloaded@- n1) e
where
	_from_by_to :: !a !a !a -> .[a] | Ord,IncDec a
	_from_by_to n s e
		| n<=e
			= [n : _from_by_to (n StdOverloaded@+ s) s e]
			= []
	_from_by_down_to :: !a !a !a -> .[a] | Ord,IncDec a
	_from_by_down_to n s e
		| n>=e
			= [n : _from_by_down_to (n StdOverloaded@+ s) s e]
			= []
