implementation module StdFloat;

import StdOverloaded;

class toFloat a	:: !a -> Float;
class fromFloat a :: !Float -> a;

instance + Float where {
	(+) a b = code inline {
		addRs
	}
}

instance - Float where {
	(-) a b = code inline {
		subRs
	}
}

instance * Float where {
	(*) a b = code inline {
		mulRs
	}
}

instance / Float where {
	(/) a b = code inline {
		divRs
	}
}

instance sqrt Float where {
	sqrt a = code inline {
		sqrtRs
	}
}

instance ~ Float where {
	~ x = code inline {
		negRs
	}
}

instance abs Float where {
	abs x = code inline {
		absRs
	}
}

instance zero Float where {
	zero = code inline {
		pushRs 0.0
	}
}

instance one Float where {
	one = code inline {
		pushRs 1.0
	}
}

instance == Float where {
	(==) a b = code inline {
		eqRs
	}
}

instance < Float where {
	(<) a b = code inline {
		 ltRs
	}
}

instance toFloat Int where {
	toFloat a = code inline {
		ItoRs
	}
}

instance toFloat Float where {
	toFloat a = code inline {
		no_op
	}
}

instance toFloat Real where {
	toFloat a = code inline {
		RtoRs
	}
}

instance fromFloat Int where {
	fromFloat a = code inline {
		RstoI
	}
}

instance fromFloat Float where {
	fromFloat a = code inline {
		no_op
	}
}

instance fromFloat Real where {
	fromFloat a = code inline {
		RstoR
	}
}

instance toReal Float where {
	toReal a = code inline {
		RstoR
	}
}

/*
instance ^ Float
instance ln Float
instance log10 Float
instance exp Float
instance sin Float
instance cos Float
instance tan Float
instance asin Float
instance acos Float
instance atan Float
instance sinh Float
instance cosh Float
instance tanh Float
instance asinh Float
instance acosh Float
instance atanh Float

instance fromFloat {#Char}
instance toFloat {#Char}

instance toInt Float
instance fromInt Float

instance fromReal float

entier :: !Float -> Int
*/
