/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
definition module Clean3Functions

import Haskell3Functions


fibsC :: [Int]

concatMap2C :: (a -> [b]) [a] -> [b]

concatMap1C :: (a -> [b]) -> ([a] -> [b])
// concatMap1C :: (ListF a b) -> ListF [a] b

concatMap0C :: ((a -> [b]) -> [a] -> [b])
