definition module Char where

from PreludeTypes import ::String
from StdChar import isDigit,isUpper,isLower,isAlpha,isPrint,toUpper,toLower

from PreludeInternal import lexLitChar,showLitChar
from PreludeLibraryInline import ord,chr

isAscii :: !Char -> Bool
isLatin1 :: !Char -> Bool
isControl :: !Char -> Bool
isSpace :: !Char -> Bool
isAlphaNum :: !Char -> Bool
isOctDigit :: !Char -> Bool
isHexDigit :: !Char -> Bool
digitToInt :: !Char -> Int
intToDigit :: !Int -> Char
readLitChar :: !String -> [(Char,String)]
