definition module Data.Int

from PreludeTypes import qualified
	class Integral,class Enum,class Real,class Ord,class Eq,class Num,class Show,
	::Integer,::Ordering,::Rational,::Ratio

:: Int8 (:==Int)
:: Int16(:==Int)
:: Int32(:==Int)

instance PreludeTypes.Eq Int32 where
	(==) :: !Int32 !Int32 -> Bool
	(/=) :: !Int32 !Int32 -> Bool

instance PreludeTypes.Ord Int32 where
	(<) infix  4 :: !Int32 !Int32 -> Bool
	(<=) infix 4 :: !Int32 !Int32 -> Bool
	(>=) infix 4 :: !Int32 !Int32 -> Bool
	(>) infix  4 :: !Int32 !Int32 -> Bool
	compare :: !Int32 !Int32 -> PreludeTypes.Ordering
	min :: !Int32 !Int32 -> Int32
	max :: !Int32 !Int32 -> Int32

instance PreludeTypes.Num Int32 where
	(+) :: !Int32 !Int32 -> Int32
	(-) :: !Int32 !Int32 -> Int32
	(*) :: !Int32 !Int32 -> Int32
	abs :: !Int32 -> Int32
	signum :: !Int32 -> Int32
	negate :: !Int32 -> Int32
	fromInteger :: !PreludeTypes.Integer -> Int32

instance PreludeTypes.Integral Int32 where
	toInteger :: !Int32 -> PreludeTypes.Integer
	quot :: !Int32 !Int32 -> Int32
	rem :: !Int32 !Int32 -> Int32
	div :: !Int32 !Int32 -> Int32
	mod :: !Int32 !Int32 -> Int32
	quotRem :: !Int32 !Int32 -> (!Int32,!Int32)
	divMod :: !Int32 !Int32 -> (!Int32,!Int32)

instance PreludeTypes.Enum Int32 where
	toEnum :: !Int -> Int32
	fromEnum :: !Int32 -> Int

instance PreludeTypes.Real Int32 where
	toRational :: !Int32 -> PreludeTypes.Rational

instance PreludeTypes.Show Int32 where
	show :: !Int32 -> [Char]
