implementation module Data.List where

genericLength :: (Integral a) => [b] -> a
genericLength [] = 0
genericLength (x:xs) = 1 + genericLength xs

zipWith4 :: (a->b->c->d->e) -> ![a] -> [b] -> [c] -> [d] -> [e]
zipWith4 z (a:as) (b:bs) (c:cs) (d:ds)
	= z a b c d : zipWith4 z as bs cs ds
zipWith4 _ _ _ _ _ = []
