implementation module Foreign.Marshal.Utils where

import Foreign.Ptr
import Foreign.Storable
import Foreign.Marshal.Alloc

with` :: (Storable a) => !a -> !(Ptr a -> IO b) -> IO b
with` val f  =
  alloca (\ptr -> do
    poke ptr val
    f ptr)

--withMany :: (a -> (b -> r) -> r) -> [a] -> ([b] -> r) -> r
{-
withMany g (x:xs) f
	= g x (\y -> withMany g xs (\ys -> f (y:ys)))
withMany _ [] f
	= f []
-}

withMany g l f
	:== withMany l f
where
	withMany (x:xs) f
		= g x (\y -> withMany xs (\ys -> f (y:ys)))
	withMany [] f
		= f []
