definition module List where

from Prelude import class Eq,class Ord,::Ordering,::Maybe(..),
					class Integral,class Enum,class Real,class Num,class Show,::Integer
from Maybe import listToMaybe

elemIndex :: Eq a => a -> ![a] -> Maybe Int special a=Char;a=Int
elemIndices :: Eq a => a -> ![a] -> [Int] special a=Char;a=Int
--find :: (a->Bool) -> [a] -> Maybe a
find p l :== find l
where
	find (e:l)
		| p e
			= Just e
			= find l
	find [] = Nothing
findIndex :: (a -> Bool) -> ![a] -> Maybe Int
findIndices :: (a -> Bool) -> ![a] -> [Int]
nub :: (Eq a) => ![a] -> [a] special a=Char;a=Int
nubBy :: (a -> a -> Bool) -> ![a] -> [a]
delete :: (Eq a) => a -> ![a] -> [a] special a=Char;a=Int
deleteBy :: (a->a->Bool) -> a -> ![a] -> [a]
(\\) infix 5 :: (Eq a) => ![a] -> ![a] -> [a] special a=Char;a=Int
deleteFirstsBy :: (a -> a -> Bool) -> ![a] -> ![a] -> [a]
union :: (Eq a) => ![a] -> [a] -> [a] special a=Char;a=Int
unionBy :: (a -> a -> Bool) -> ![a] -> [a] -> [a]
intersect :: (Eq a) => ![a] -> [a] -> [a] special a=Char;a=Int
intersectBy :: (a -> a -> Bool) -> ![a] -> [a] -> [a]
intersperse :: a -> ![a] -> [a]
transpose :: ![[a]] -> [[a]]
partition :: (a->Bool) -> ![a] -> ([a],[a])
group :: (Eq a) => ![a] -> [[a]] special a=Char;a=Int
groupBy :: (a -> a -> Bool) -> ![a] -> [[a]]
inits :: ![a] -> [[a]]
tails :: ![a] -> [[a]]
isPrefixOf :: Eq a => ![a] -> [a] -> Bool special a=Char;a=Int
isSuffixOf :: Eq a => ![a] -> [a] -> Bool special a=Char;a=Int
mapAccumL :: (s -> a -> (s, b)) -> s -> ![a] -> (s, [b])
mapAccumR :: (s -> a -> (s, b)) -> s -> ![a] -> (s, [b])
unfoldr :: !(b -> Maybe (a,b)) -> b -> [a]
sort :: (Ord a) => ![a] -> [a] special a=Int;a=Double;a=Float;a=Char;a=Integer
sortBy :: (a -> a -> Ordering) -> ![a] -> [a]
insert :: (Ord a) => a -> ![a] -> [a]
	special a=Int:==insert`Int; a=Char:==insert`Char; a=Double:==insert`Double; a=Float:==insert`Float
insert`Int :: Int -> ![Int] -> [Int]
insert`Char :: Char -> ![Char] -> [Char]
insert`Double :: Double -> ![Double] -> [Double]
insert`Float :: Float -> ![Float] -> [Float]
maximumBy :: (a -> a -> Ordering) -> ![a] -> a
minimumBy :: (a -> a -> Ordering) -> ![a] -> a
insertBy :: (a -> a -> Ordering) -> a -> ![a] -> [a]
zip4 :: ![a] -> [b] -> [c] -> [d] -> [(a,b,c,d)]
zip5 :: ![a] -> [b] -> [c] -> [d] -> [e] -> [(a,b,c,d,e)]
zip6 :: ![a] -> [b] -> [c] -> [d] -> [e] -> [f] -> [(a,b,c,d,e,f)]
zip7 :: ![a] -> [b] -> [c] -> [d] -> [e] -> [f] -> [g] -> [(a,b,c,d,e,f,g)]
zipWith4 :: (a->b->c->d->e) -> ![a]->[b]->[c]->[d]->[e]
zipWith5 :: (a->b->c->d->e->f) -> ![a]->[b]->[c]->[d]->[e]->[f]
zipWith6 :: (a->b->c->d->e->f->g) -> ![a]->[b]->[c]->[d]->[e]->[f]->[g]
zipWith7 :: (a->b->c->d->e->f->g->h) -> ![a]->[b]->[c]->[d]->[e]->[f]->[g]->[h]
unzip4 :: ([(a,b,c,d)] -> ([a],[b],[c],[d]))
unzip5 :: ([(a,b,c,d,e)] -> ([a],[b],[c],[d],[e]))
unzip6 :: ([(a,b,c,d,e,f)] -> ([a],[b],[c],[d],[e],[f]))
unzip7 :: ([(a,b,c,d,e,f,g)] -> ([a],[b],[c],[d],[e],[f],[g]))
genericLength :: (Integral a) => ![b] -> a special a=Int;a=Integer
genericTake :: (Integral a) => a -> ![b] -> [b] special a=Int;a=Integer
genericDrop :: (Integral a) => !a -> ![b] -> [b] special a=Int;a=Integer
genericSplitAt :: (Integral a) => !a -> [b] -> ([b],[b]) special a=Int;a=Integer
genericIndex :: (Integral a) => ![b] -> !a -> b special a=Int;a=Integer
genericReplicate :: (Integral a) => a -> b -> [b] special a=Int;a=Integer
