definition module Maybe where

from PreludeTypes import ::Maybe

isJust :: !Maybe a -> Bool
isNothing :: !Maybe a -> Bool
fromJust :: !Maybe a -> a
fromMaybe :: a -> !(Maybe a) -> a
maybeToList :: !(Maybe a) -> [a]
listToMaybe :: ![a] -> Maybe a
catMaybes :: ![Maybe a] -> [a]
mapMaybe :: (a -> Maybe b) -> ([a] -> [b])

