implementation module PreludeInlineFunctions where

import PreludeTypes,StdMisc

subtract :: (Num a) => a -> a -> a
subtract a b = b-a

subtract`Int :: !Int -> !Int -> Int
subtract`Int a b = `code inline {
	push_b 1
	update_b 1 2
	updatepop_b 0 1
	subI
}

subtract`Double :: !Double -> !Double -> Double
subtract`Double a b = `code inline {
	push_b 3
	push_b 3
	update_b 3 5
	update_b 2 4
	update_b 1 3
	updatepop_b 0 2
	subR
}

subtract`Float :: !Float -> !Float -> Float
subtract`Float a b = `code inline {
	push_b 3
	push_b 3
	update_b 3 5
	update_b 2 4
	update_b 1 3
	updatepop_b 0 2
	subR
}

even :: (Integral a) => a -> Bool
even n = n `rem` 2 == 0

even`Int :: !Int -> Bool
even`Int n = `code inline {
	pushI 1
	and%
	pushI 0
	eqI
}

even`Integer :: !Integer -> Bool
even`Integer {integer_s,integer_a}
	| size integer_a==0
		= even`Int integer_s
		= even`Int integer_a~[0]

odd :: (Integral a) => a -> Bool
odd n = not (n `rem` 2 == 0)

odd`Int :: !Int -> Bool
odd`Int n = `code inline {
	pushI 1
	and%
	pushI 0
	eqI
	notB
}

odd`Integer :: !Integer -> Bool
odd`Integer {integer_s,integer_a}
	| size integer_a==0
		= odd`Int integer_s
		= odd`Int integer_a~[0]
