definition module PreludeInternal where

from PreludeTypes import ::Integer
from StdInt import qualified IF_INT_64_OR_32

string_to_char_list :: !{#Char} -> [Char]
string_to_char_list_append :: !{#Char} -> [Char] -> [Char]
char_list_to_string :: ![Char] -> *{#Char}
char_list_to_zstring :: [Char] -> *{#Char}

lexLitChar :: ![Char] -> [([Char],[Char])]
readEsc :: ![Char] -> [(Char,[Char])]
read_rest_int :: ![Char] -> !Int -> (!Int,![Char])
read_rest_oct_int :: ![Char] -> !Int -> (!Int,![Char])
read_rest_hex_int :: ![Char] -> !Int -> (!Int,![Char])
showLitChar :: !Char -> ([Char] -> [Char])

n_leading_zeros n :== StdInt.IF_INT_64_OR_32 (n_leading_zeros_64 n) (n_leading_zeros_32 n)
n_leading_zeros_64 :: !Int -> Int
n_leading_zeros_32 :: !Int -> Int

int_array_to_unsigned_integer :: !*{#Int} -> *Integer;
