definition module PreludeShow where

from PreludeTypes import
	::ShowS,::String,::(),::Ordering,::Maybe,::Either,
	class Show

showParen :: !Bool -> ShowS -> ShowS

instance Show Int where
	show :: !Int -> [Char]

instance Show Double where
	show :: !Double -> [Char]

instance Show Float where
	show :: !Float -> [Char]

instance Show Char where
	show :: !Char -> [Char]
	showsPrec :: Int -> !Char -> ([Char]->[Char])
	showList :: [Char] -> ([Char]->[Char])

instance Show Bool where
	show :: !Bool -> [Char]

instance Show () where
	show :: !() -> [Char]

instance Show Ordering

instance (Show a) =>
	Show (Maybe a)

instance (Show a,Show b) =>
	Show (Either a b)

instance (Show a) =>
	Show [a]

instance (Show e0,Show e1) =>
	Show (e0,e1)
instance (Show e0,Show e1,Show e2) =>
	Show (e0,e1,e2)
instance (Show e0,Show e1,Show e2,Show e3) =>
	Show (e0,e1,e2,e3)
instance (Show e0,Show e1,Show e2,Show e3,Show e4) =>
	Show (e0,e1,e2,e3,e4)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5) =>
	Show (e0,e1,e2,e3,e4,e5)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5,Show e6) =>
	Show (e0,e1,e2,e3,e4,e5,e6)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5,Show e6,Show e7) =>
	Show (e0,e1,e2,e3,e4,e5,e6,e7)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5,Show e6,Show e7,Show e8) =>
	Show (e0,e1,e2,e3,e4,e5,e6,e7,e8)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5,Show e6,Show e7,Show e8,Show e9) =>
	Show (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5,Show e6,Show e7,Show e8,Show e9,Show e10) =>
	Show (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5,Show e6,Show e7,Show e8,Show e9,Show e10,Show e11) =>
	Show (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5,Show e6,Show e7,Show e8,Show e9,Show e10,Show e11,Show e12) =>
	Show (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5,Show e6,Show e7,Show e8,Show e9,Show e10,Show e11,Show e12,Show e13) =>
	Show (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13)
instance (Show e0,Show e1,Show e2,Show e3,Show e4,Show e5,Show e6,Show e7,Show e8,Show e9,Show e10,Show e11,Show e12,Show e13,Show e14) =>
	Show (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14)
